'       Complete Screen 13 Font Routines
'
'       Programmed by: DarkDread
'
'       This is a simple to use font routine which is compatible with VGA
'       mode 13h.  All of the fonts are in the 'FONTS.DAT' file, which is
'       loaded into the ChrSet 3D array.  Below is an explanation of the
'       SUB's and how to use them.
'
'       One more thing, if you find these routines useful and decide to
'       include them in one of your programs don't forget to credit me.
'       Something like: Font routines created by: DarkDread.
'
'       LoadFonts
'       Usage:  CALL LoadFonts
'       - This SUB must be called in order to use the font routine.  It
'         will load all of the fonts into the ChrSet array, which must be
'         included (DIM SHARED ChrSet(33 TO 122, 1 TO 8, 1 TO 8) AS INTEGER)
'         at the start of your program.  The optional status bar which this
'         SUB uses may be removed.  It is not necessary.
'
'       PutNumber
'       Usage:   CALL PutNumber (Number, XPos, YPos, Digits)
'       Example: CALL PutNumber (500, 0, 0, 4)
'       - Use this SUB if you wish to print an numerical value using the
'         font routine.  No string characters may be used for this SUB.
'       Number:  Enter your number value which you wish to print using the
'                font routine here.  You may enter a variable.
'       XPos:    Any value from 0 to 319.  This is the X position in pixels
'                of where your number will be placed.
'       YPos:    Any value from 0 to 199.  This is the Y position in pixels
'                of where your number will be placed.
'       Digits:  This is the same as Qbasic's PRINT USING "###" command,
'                which allows you to print your values in neat columns.
'                IE. If all of your numbers were less than, say 5 digits                you could
'                long, you could use 5 for the Digits value and all of your
'                numbers would be 'right justified' if you used the same Y
'                position for each one.  If you want your number to be
'                printed normally then enter 0 as the value for Digits.
'
'       PutText
'       Usage:   CALL PutText (XPos, YPos, Text)
'       Example: CALL PutText (0, 8, "This is the font routine.")
'       - Use this SUB if you wish to print words, characters, and non-
'         value numbers using the font routine.  You must place your string
'         in quotations just like Qbasic's PRINT command.
'       XPos:    Any Value from 0 to 319.  This is the X position in pixels
'                of where your string will be placed.
'       YPos:    Any value from 0 to 199.  This is the Y position in pixels
'                of where your string will be placed.
'       Text:    This is where you type in your string.  Don't forget that
'                you must put quotations around it.
'

DECLARE SUB PutNumber (Value%, X%, Y%, Digits%)
DECLARE SUB PutText (PosX%, PosY%, Sentence$)
DECLARE SUB ReadFont ()
DECLARE SUB LoadFonts ()

DIM SHARED ChrSet(33 TO 122, 1 TO 8, 1 TO 8) AS INTEGER

DEFINT A-Z

CLS

CALL LoadFonts

SCREEN 13

Colour = 16
FOR Y1 = 0 TO 520
    'PRINT X1, Y1
    LINE (X1, 0)-(0, Y1), Colour
    IF ColourType = 0 THEN
        Colour = Colour + 1
      ELSEIF ColourType = 1 THEN
        Colour = Colour - 1
    END IF
    IF Colour = 23 THEN ColourType = 1
    IF Colour = 16 THEN ColourType = 0
    X1 = X1 + 1
NEXT Y1

CALL PutText(0, 0, "VGA mode 13h Font Routine")
CALL PutText(0, 16, "Programmed by: DarkDread")
CALL PutText(0, 32, "     You may use these font routines in ")
CALL PutText(0, 40, "any of your programs as long as you give")
CALL PutText(0, 48, "me credit.")
CALL PutText(0, 56, "     On a Pentium computer, these things")
CALL PutText(0, 64, "should fly.  On my 386, they scroll in  ")
CALL PutText(0, 72, "very quick so you shouldn't worry about ")
CALL PutText(0, 80, "speed.  You can slow down the printing  ")
CALL PutText(0, 88, "as well for a 'scroll in' effect similar")
CALL PutText(0, 96, "to what some RPG's use in the storyline.")
CALL PutText(0, 104, "     You can also put these fonts in any")
CALL PutText(0, 112, "spot on the screen, not just 25 rows and")
CALL PutText(0, 120, "40 columns (ie. These fonts can be used ")
CALL PutText(0, 128, "for scrolling credits, like a movie.)")
CALL PutText(0, 144, "     Well, that's it for me, have fun   ")
CALL PutText(0, 152, "with these things.  Make some use of    ")
CALL PutText(0, 160, "them!")
CALL PutText(0, 188, "                         DarkDread, 1997")

Start1 = 17: End1 = 24
Start2 = 16: End2 = 16

I = 5

WHILE INKEY$ = ""
  IF Start1 = 25 THEN
    Start1 = 17
    End2 = 16
  END IF
    FOR Colour = Start1 TO End1
        OUT &H3C8, Colour
        OUT &H3C9, I
        OUT &H3C9, I
        OUT &H3C9, I
        IF I = 0 THEN
            I = 5
          ELSEIF I = 26 THEN
            I = 0
          ELSE
            I = I + 3
        END IF
        FOR Pause = 1 TO 300: NEXT Pause
    NEXT Colour
    FOR Colour = Start2 TO End2
        OUT &H3C8, Colour
        OUT &H3C9, I
        OUT &H3C9, I
        OUT &H3C9, I
        IF I = 0 THEN
            I = 5
          ELSEIF I = 26 THEN
            I = 0
          ELSE
            I = I + 3
        END IF
        FOR Pause = 1 TO 300: NEXT Pause
    NEXT Colour
    Start1 = Start1 + 1
    End2 = End2 + 1
WEND

END

SUB LoadFonts
  SHARED Font AS INTEGER, X AS INTEGER, Y AS INTEGER
  PRINT "Loading fonts: ";      '       Comment to remove status bar.
  COLOR 4                       '       Comment to remove status bar.
  FOR I = 1 TO 85               '       Comment to remove status bar.
    PRINT CHR$(219);            '       Comment to remove status bar.
  NEXT I                        '       Comment to remove status bar.
  COLOR 14                      '       Comment to remove status bar.
  LOCATE 1, 16                  '       Comment to remove status bar.
  OPEN "FONTS.DAT" FOR INPUT AS #1
  Font = 32
  DO
    Font = Font + 1
    FOR Y = 1 TO 8
      FOR X = 1 TO 8
        INPUT #1, ChrSet(Font, X, Y)
      NEXT X
    NEXT Y
    PRINT CHR$(219);            '       Comment to remove status bar.
  LOOP UNTIL Font = 122
  CLOSE #1
  COLOR 7
END SUB

SUB PutNumber (Value%, PosX%, PosY%, Digits%)
  Sentence$ = RIGHT$(STR$(Value%), LEN(STR$(Value%)) - 1)
  IF Digits% - LEN(Sentence$) > 0 THEN
    Sentence$ = SPACE$(Digits% - LEN(Sentence$)) + Sentence$
  END IF
  FOR Csr = 1 TO LEN(Sentence$)
    Number = ASC(MID$(Sentence$, Csr, 1))
    IF Number > 32 THEN
      FOR Y = 1 TO 8
        FOR X = 1 TO 8
          IF ChrSet(Number, X, Y) <> 0 THEN PSET (PosX + (X - 1), PosY + (Y - 1)), ChrSet(Number, X, Y)
        NEXT X
      NEXT Y
    END IF
    PosX = PosX + 8
    IF PosX = 320 THEN
      PosX = 0
      PosY = PosY + 8
    END IF
  NEXT Csr
END SUB

SUB PutText (PosX%, PosY%, Sentence$)
  FOR Csr = 1 TO LEN(Sentence$)
    Number = ASC(MID$(Sentence$, Csr, 1))
    IF Number > 32 THEN
      FOR Y = 1 TO 8
        FOR X = 1 TO 8
          IF ChrSet(Number, X, Y) <> 0 THEN PSET (PosX + (X - 1), PosY + (Y - 1)), ChrSet(Number, X, Y)
        NEXT X
      NEXT Y
    END IF
    PosX = PosX + 8
    IF PosX = 320 THEN
      PosX = 0
      PosY = PosY + 8
    END IF
  NEXT Csr
END SUB

